## openfpgaloader 0.10.0+git20230202

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# set the project name
project(openFPGALoader VERSION "0.10.0" LANGUAGES CXX)
add_definitions(-DVERSION=\"v${PROJECT_VERSION}\")

option(BUILD_STATIC "Whether or not to build with static libraries" OFF)
if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	set(ENABLE_UDEV OFF)
else()
	option(ENABLE_UDEV "use udev to search JTAG adapter from /dev/xx" ON)
endif()
option(ENABLE_CMSISDAP "enable cmsis DAP interface (requires hidapi)" ON)
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	option(ENABLE_LIBGPIOD "enable libgpiod bitbang driver (requires libgpiod)" ON)
else()
	set(ENABLE_LIBGPIOD OFF)
endif()
option(USE_PKGCONFIG "Use pkgconfig to find libraries" ON)
option(LINK_CMAKE_THREADS "Use CMake find_package to link the threading library" OFF)
set(ISE_PATH "/opt/Xilinx/14.7" CACHE STRING "ise root directory (default: /opt/Xilinx/14.7)")

## specify the C++ standard
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wextra ${CMAKE_CXX_FLAGS_DEBUG}")

if (BUILD_STATIC)
	set(CMAKE_EXE_LINKER_FLAGS "-static-libstdc++ -static ${CMAKE_EXE_LINKER_FLAGS}")
	set(BUILD_SHARED_LIBS OFF)
endif()

include(GNUInstallDirs)
# By default: DATA_DIR="/usr/local/share"
add_definitions(-DDATA_DIR=\"${CMAKE_INSTALL_FULL_DATAROOTDIR}\")

add_definitions(-DISE_DIR=\"${ISE_PATH}\")

if (USE_PKGCONFIG)
	find_package(PkgConfig REQUIRED)
	pkg_check_modules(LIBFTDI REQUIRED libftdi1)
	pkg_check_modules(LIBUSB REQUIRED libusb-1.0)
	pkg_check_modules(HIDAPI hidapi-hidraw)
	# if hidraw not found try with libusb
	if (NOT HIDAPI_FOUND)
		pkg_check_modules(HIDAPI hidapi-libusb)
	endif()
	# zlib support (gzip)
	pkg_check_modules(ZLIB zlib)
	if (NOT ZLIB_FOUND)
		# try zlib-ng
		pkg_check_modules(ZLIB zlib-ng)
		if (ZLIB_FOUND)
			add_definitions(-DHAS_ZLIBNG)
		else()
			message(FATAL_ERROR "Could find ZLIB")
		endif()
	endif(NOT ZLIB_FOUND)

	if (ENABLE_UDEV)
		pkg_check_modules(LIBUDEV libudev)
		if (LIBUDEV_FOUND)
			add_definitions(-DUSE_UDEV)
		else()
			message("libudev not found, disabling udev support and -D parameter")
			set(ENABLE_UDEV OFF)
		endif()
	endif()

	if (ENABLE_LIBGPIOD)
		pkg_check_modules(LIBGPIOD libgpiod)
		if (NOT LIBGPIOD_FOUND)
			message("libgpiod not found, disabling gpiod support")
			set(ENABLE_LIBGPIOD OFF)
		endif()
	endif()
endif()

set(OPENFPGALOADER_SOURCE
	src/anlogic.cpp
	src/anlogicBitParser.cpp
	src/anlogicCable.cpp
	src/ch552_jtag.cpp
	src/dfu.cpp
	src/dfuFileParser.cpp
	src/dirtyJtag.cpp
	src/efinix.cpp
	src/efinixHexParser.cpp
	src/fx2_ll.cpp
	src/ice40.cpp
	src/ihexParser.cpp
	src/pofParser.cpp
	src/rawParser.cpp
	src/spiFlash.cpp
	src/spiInterface.cpp
	src/usbBlaster.cpp
	src/epcq.cpp
	src/svf_jtag.cpp
	src/jedParser.cpp
	src/feaparser.cpp
	src/display.cpp
	src/jtag.cpp
	src/ftdiJtagBitbang.cpp
	src/ftdiJtagMPSSE.cpp
	src/configBitstreamParser.cpp
	src/ftdipp_mpsse.cpp
	src/main.cpp
	src/latticeBitParser.cpp
	src/libusb_ll.cpp
	src/gowin.cpp
	src/device.cpp
	src/jlink.cpp
	src/lattice.cpp
	src/progressBar.cpp
	src/fsparser.cpp
	src/mcsParser.cpp
	src/ftdispi.cpp
	src/altera.cpp
	src/bitparser.cpp
	src/xilinx.cpp
	src/xilinxMapParser.cpp
	src/colognechip.cpp
	src/colognechipCfgParser.cpp
)

set(OPENFPGALOADER_HEADERS
	src/altera.hpp
	src/anlogic.hpp
	src/anlogicBitParser.hpp
	src/anlogicCable.hpp
	src/ch552_jtag.hpp
	src/cxxopts.hpp
	src/dfu.hpp
	src/dfuFileParser.hpp
	src/dirtyJtag.hpp
	src/efinix.hpp
	src/efinixHexParser.hpp
	src/fx2_ll.hpp
	src/ice40.hpp
	src/ihexParser.hpp
	src/pofParser.hpp
	src/progressBar.hpp
	src/rawParser.hpp
	src/usbBlaster.hpp
	src/bitparser.hpp
	src/ftdiJtagBitbang.hpp
	src/ftdiJtagMPSSE.hpp
	src/jlink.hpp
	src/jtag.hpp
	src/jtagInterface.hpp
	src/libusb_ll.hpp
	src/fsparser.hpp
	src/part.hpp
	src/board.hpp
	src/jedParser.hpp
	src/feaparser.hpp
	src/display.hpp
	src/mcsParser.hpp
	src/ftdipp_mpsse.hpp
	src/spiFlash.hpp
	src/spiFlashdb.hpp
	src/epcq.hpp
	src/spiInterface.hpp
	src/svf_jtag.hpp
	src/configBitstreamParser.hpp
	src/device.hpp
	src/gowin.hpp
	src/cable.hpp
	src/ftdispi.hpp
	src/lattice.hpp
	src/latticeBitParser.hpp
	src/xilinx.hpp
	src/xilinxMapParser.hpp
	src/colognechip.hpp
	src/colognechipCfgParser.hpp
)

link_directories(
	${LIBUSB_LIBRARY_DIRS}
	${LIBFTDI_LIBRARY_DIRS}
)

add_executable(openFPGALoader
	${OPENFPGALOADER_SOURCE}
	${OPENFPGALOADER_HEADERS}
)

include_directories(
	${LIBUSB_INCLUDE_DIRS}
	${LIBFTDI_INCLUDE_DIRS}
)

target_link_libraries(openFPGALoader
	${LIBUSB_LIBRARIES}
	${LIBFTDI_LIBRARIES}
)

if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	# winsock provides ntohs
	target_link_libraries(openFPGALoader ws2_32)
	
	target_sources(openFPGALoader PRIVATE src/pathHelper.cpp)	
	list(APPEND OPENFPGALOADER_HEADERS src/pathHelper.hpp)
endif()

# libusb_attach_kernel_driver is only available on Linux.
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	add_definitions(-DATTACH_KERNEL)
endif()

if (ENABLE_UDEV)
	include_directories(${LIBUDEV_INCLUDE_DIRS})
	target_link_libraries(openFPGALoader ${LIBUDEV_LIBRARIES})
endif()

if (ENABLE_LIBGPIOD)
	link_directories(${LIBGPIOD_LIBRARY_DIRS})
	include_directories(${LIBGPIOD_INCLUDE_DIRS})
	target_link_libraries(openFPGALoader ${LIBGPIOD_LIBRARIES})
	add_definitions(-DENABLE_LIBGPIOD=1)
	target_sources(openFPGALoader PRIVATE src/libgpiodJtagBitbang.cpp)
	list (APPEND OPENFPGALOADER_HEADERS src/libgpiodJtagBitbang.hpp)
	message("libgpiod support enabled")
endif(ENABLE_LIBGPIOD)

if (ENABLE_JETSONNANOGPIO)
	add_definitions(-DENABLE_JETSONNANOGPIO=1)
	target_sources(openFPGALoader PRIVATE src/jetsonNanoJtagBitbang.cpp)
	list (APPEND OPENFPGALOADER_HEADERS src/jetsonNanoJtagBitbang.hpp)
	message("Jetson Nano GPIO support enabled")
endif(ENABLE_JETSONNANOGPIO)

if (ENABLE_UDEV OR ENABLE_LIBGPIOD OR ENABLE_JETSONNANOGPIO)
	add_definitions(-DUSE_DEVICE_ARG)
endif(ENABLE_UDEV OR ENABLE_LIBGPIOD OR ENABLE_JETSONNANOGPIO)

if (BUILD_STATIC)
	set_target_properties(openFPGALoader PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

if (ENABLE_CMSISDAP)
	if (HIDAPI_FOUND)
		include_directories(${HIDAPI_INCLUDE_DIRS})
		target_link_libraries(openFPGALoader ${HIDAPI_LIBRARIES})
		add_definitions(-DENABLE_CMSISDAP=1)
		target_sources(openFPGALoader PRIVATE src/cmsisDAP.cpp)
		list (APPEND OPENFPGALOADER_HEADERS src/cmsisDAP.hpp)
		message("cmsis_dap support enabled")
	else()
		message("hidapi-libusb not found: cmsis_dap support disabled")
	endif()
endif(ENABLE_CMSISDAP)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	add_definitions(-DENABLE_XVC=1)
	target_sources(openFPGALoader PRIVATE src/xvc_client.cpp src/xvc_server.cpp)
	list (APPEND OPENFPGALOADER_HEADERS src/xvc_client.hpp src/xvc_server.cpp)
	set(CMAKE_EXE_LINKER_FLAGS "-pthread ${CMAKE_EXE_LINKER_FLAGS}")
	message("Xilinx Virtual Server support enabled")
else()
		message("Xilinx Virtual Server support disabled")
endif()

if (ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIRS})
	target_link_libraries(openFPGALoader ${ZLIB_LIBRARIES})
	add_definitions(-DHAS_ZLIB=1)
else()
	message("zlib library not found: can't flash intel/altera devices")
endif()

if (LINK_CMAKE_THREADS)
	find_package(Threads REQUIRED)
	target_link_libraries(openFPGALoader Threads::Threads)
endif()

# libftdi < 1.4 as no usb_addr
# libftdi >= 1.5 as purge_buffer obsolete
string(REPLACE "." ";" VERSION_LIST ${LIBFTDI_VERSION})
list(GET VERSION_LIST 0 LIBFTDI_VERSION_MAJOR)
list(GET VERSION_LIST 1 LIBFTDI_VERSION_MINOR)
math(EXPR FTDI_VAL "${LIBFTDI_VERSION_MAJOR} * 100 + ${LIBFTDI_VERSION_MINOR}")

add_definitions(-DFTDI_VERSION=${FTDI_VAL})

install(TARGETS openFPGALoader DESTINATION bin)

file(GLOB GZ_FILES spiOverJtag/spiOverJtag_*.*.gz)

# Compress rbf and bit files present into repository
# TODO: test compat with Windows and MacOS
list(INSERT CMAKE_MODULE_PATH 0 ${PROJECT_SOURCE_DIR}/cmake/Modules)
include(FindGZIP)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND GZIP_PRG)
	set(SPIOVERJTAG_DIR "${CMAKE_CURRENT_SOURCE_DIR}/spiOverJtag")
	file(GLOB BITS_FILES RELATIVE ${SPIOVERJTAG_DIR} spiOverJtag/spiOverJtag_*.bit)
	file(GLOB RBF_FILES RELATIVE ${SPIOVERJTAG_DIR} spiOverJtag/spiOverJtag_*.rbf)

	STRING(REGEX REPLACE ".bit" ".bit.gz" BIT_GZ_FILES "${BITS_FILES}")
	STRING(REGEX REPLACE ".rbf" ".rbf.gz" RBF_GZ_FILES "${RBF_FILES}")

	FOREACH(bit ${BITS_FILES} ${RBF_FILES})
		ADD_CUSTOM_COMMAND(OUTPUT ${bit}.gz
			COMMAND ${GZIP_PRG} -9 -c ${bit} > ${CMAKE_CURRENT_BINARY_DIR}/${bit}.gz
			DEPENDS ${SPIOVERJTAG_DIR}/${bit}
			WORKING_DIRECTORY ${SPIOVERJTAG_DIR}
			COMMENT "Building ${bit}.gz")
		list(APPEND GZ_FILES ${CMAKE_CURRENT_BINARY_DIR}/${bit}.gz)
	ENDFOREACH(bit)

	ADD_CUSTOM_TARGET(bit ALL DEPENDS ${BIT_GZ_FILES} ${RBF_GZ_FILES})
else()
	file(GLOB BITS_FILES spiOverJtag/spiOverJtag_*.bit)
	file(GLOB RBF_FILES spiOverJtag/spiOverJtag_*.rbf)
	install(FILES
		${BITS_FILES}
		${RBF_FILES}
		DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/openFPGALoader
	)
endif()

install(FILES 
	${GZ_FILES}
	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/openFPGALoader
)

=== spiOverJtag/Makefile ===
XILINX_PARTS := xc3s500evq100 xc6slx9tqg144 xc6slx16ftg256 xc6slx16csg324 xc6slx45csg324 xc6slx100fgg484 \
	xc6slx150tfgg484 \
	xc7a35tcpg236 xc7a35tcsg324 xc7a35tftg256 \
	xc7a50tcsg324 xc7a50tcpg236 xc7a75tfgg484 \
	xc7a100tcsg324 xc7a100tfgg484 xc7a100tfgg676\
	xc7a200tsbg484 \
	xc7s25csga225 xc7s25csga324 xc7s50csga324 \
	xc7k160tffg676 \
	xc7k325tffg676 xc7k325tffg900 \
	xc7k420tffg901 \
	xcvu9p-flga2104
XILINX_BIT_FILES := $(addsuffix .bit.gz,$(addprefix spiOverJtag_, $(XILINX_PARTS)))

ALTERA_PARTS := 10cl025256 10cl055484 ep4ce2217 ep4ce1523 ep4ce11523 5ce223 5ce423 5ce523 5ce927
ALTERA_BIT_FILES := $(addsuffix .rbf.gz, $(addprefix spiOverJtag_, $(ALTERA_PARTS)))

BIT_FILES := $(ALTERA_BIT_FILES) $(XILINX_BIT_FILES)

all: $(BIT_FILES)

$(XILINX_BIT_FILES) : spiOverJtag_%.bit.gz : tmp_%/spiOverJtag.bit
	gzip -9 -c $< > $@
tmp_%/spiOverJtag.bit : xilinx_spiOverJtag.v
	./build.py $*

$(ALTERA_BIT_FILES): spiOverJtag_%.rbf.gz: tmp_%/spiOverJtag.rbf
	gzip -9 -c $< > $@
tmp_%/spiOverJtag.rbf: tmp_%/spiOverJtag.sof
	quartus_cpf --option=bitstream_compression=off -c $< $@

tmp_%/spiOverJtag.sof: altera_spiOverJtag.v
	./build.py $*

clean:
	-rm -rf tmp_* *.jou *.log .Xil

## openfpgaloader 0.10.0+git20230202-edea24f

=== debian/changelog ===
openfpgaloader (0.10.0+git20230202-edea24f-1) unstable; urgency=medium

  * Initial source upload after package was accepted.
    - adopts upstream's improved handling of compressed firmwares.

 -- Steffen Moeller <moeller@debian.org>  Fri, 03 Feb 2023 17:30:59 +0100
 

openfpgaloader (0.10.0-3) unstable; urgency=medium

  * Initial release. (Closes: #1018294)
  * d/copyright: Fixed omission of new contributors 
  * d/u/metadata: Added SciCrunch RRID

 -- Steffen Moeller <moeller@debian.org>  Sat, 14 Jan 2023 01:38:40 +0100

openfpgaloader (0.10.0-1) UNRELEASED; urgency=medium

  * New upstream version
    - upstream kindly removed non-DFSG-compliant file from source tree
  * Standards-Version: 4.6.2
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Steffen Moeller <moeller@debian.org>  Thu, 22 Dec 2022 15:16:35 +0100

openfpgaloader (0.9.0-1) UNRELEASED; urgency=medium

  * Initial upload to experimental.

 -- Steffen Moeller <moeller@debian.org>  Sun, 28 Aug 2022 15:38:29 +0200

=== debian/control ===
Source: openfpgaloader
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libftdi1-dev,
 libhidapi-dev,
 libudev-dev,
 libusb-dev,
 zlib1g-dev,
 libgpiod-dev,
 cmake,
 pkg-config
Standards-Version: 4.6.2
Homepage: https://github.com/trabucayre/openFPGALoader
Vcs-Browser: https://salsa.debian.org/electronics-team/openfpgaloader
Vcs-Git: https://salsa.debian.org/electronics-team/openfpgaloader.git

Package: openfpgaloader
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests: yosys
Description: Universal utility for programming FPGAs
 FPGAs are software-programmable reconfigurable circuits that when
 may implement arbitrary logics, be it to interface to other hardware
 as some sort of glue logic or to even outsource computations from your
 CPU as an accelerator. Even small FPGAs are today sufficiently capable
 to simulate a CPU.
 .
 This package knows how to bring the firmware that is built on a regular
 computer, e.g., with yosys and assorted tools, to the FPGA board, such
 that such a bitstream is then executed.
 .
 OpenFPGALoader is compatible with many boards, cables and FPGA from
 major manufacturers (Xilinx, Altera/Intel, Lattice, Gowin, Efinix,
 Anlogic, Cologne Chip).

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

## openfpgaloader 0.12.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,10 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5)
 
 # set the project name
-project(openFPGALoader VERSION "0.10.0" LANGUAGES CXX)
+project(openFPGALoader VERSION "0.12.0" LANGUAGES CXX)
 add_definitions(-DVERSION=\"v${PROJECT_VERSION}\")
 
+option(ENABLE_OPTIM "Enable build with -O3 optimization level" ON)
 option(BUILD_STATIC "Whether or not to build with static libraries" OFF)
 if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
 	set(ENABLE_UDEV OFF)
@@ -13,17 +14,23 @@
 option(ENABLE_CMSISDAP "enable cmsis DAP interface (requires hidapi)" ON)
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 	option(ENABLE_LIBGPIOD "enable libgpiod bitbang driver (requires libgpiod)" ON)
+	option(ENABLE_REMOTEBITBANG "enable remote bitbang driver" ON)
 else()
 	set(ENABLE_LIBGPIOD OFF)
+	set(ENABLE_REMOTEBITBANG OFF)
 endif()
 option(USE_PKGCONFIG "Use pkgconfig to find libraries" ON)
 option(LINK_CMAKE_THREADS "Use CMake find_package to link the threading library" OFF)
+set(BLASTERII_PATH "" CACHE STRING "usbBlasterII firmware directory")
 set(ISE_PATH "/opt/Xilinx/14.7" CACHE STRING "ise root directory (default: /opt/Xilinx/14.7)")
 
 ## specify the C++ standard
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED True)
 set(CMAKE_CXX_FLAGS_DEBUG "-g -Wall -Wextra ${CMAKE_CXX_FLAGS_DEBUG}")
+if (ENABLE_OPTIM)
+	set(CMAKE_CXX_FLAGS "-O3 ${CMAKE_CXX_FLAGS}")
+endif()
 
 if (BUILD_STATIC)
 	set(CMAKE_EXE_LINKER_FLAGS "-static-libstdc++ -static ${CMAKE_EXE_LINKER_FLAGS}")
@@ -35,6 +42,7 @@
 add_definitions(-DDATA_DIR=\"${CMAKE_INSTALL_FULL_DATAROOTDIR}\")
 
 add_definitions(-DISE_DIR=\"${ISE_PATH}\")
+add_definitions(-DBLASTERII_DIR=\"${BLASTERII_PATH}\")
 
 if (USE_PKGCONFIG)
 	find_package(PkgConfig REQUIRED)
@@ -44,6 +52,9 @@
 	# if hidraw not found try with libusb
 	if (NOT HIDAPI_FOUND)
 		pkg_check_modules(HIDAPI hidapi-libusb)
+	endif()
+	if (NOT HIDAPI_FOUND)
+		pkg_check_modules(HIDAPI hidapi)
 	endif()
 	# zlib support (gzip)
 	pkg_check_modules(ZLIB zlib)
@@ -81,9 +92,11 @@
 	src/anlogicBitParser.cpp
 	src/anlogicCable.cpp
 	src/ch552_jtag.cpp
+	src/common.cpp
 	src/dfu.cpp
 	src/dfuFileParser.cpp
 	src/dirtyJtag.cpp
+	src/ch347jtag.cpp
 	src/efinix.cpp
 	src/efinixHexParser.cpp
 	src/fx2_ll.cpp
@@ -129,10 +142,12 @@
 	src/anlogicBitParser.hpp
 	src/anlogicCable.hpp
 	src/ch552_jtag.hpp
+	src/common.hpp
 	src/cxxopts.hpp
 	src/dfu.hpp
 	src/dfuFileParser.hpp
 	src/dirtyJtag.hpp
+	src/ch347jtag.hpp
 	src/efinix.hpp
 	src/efinixHexParser.hpp
 	src/fx2_ll.hpp
@@ -180,6 +195,14 @@
 	${LIBFTDI_LIBRARY_DIRS}
 )
 
+if (ENABLE_LIBGPIOD)
+	link_directories(${LIBGPIOD_LIBRARY_DIRS})
+endif()
+
+if (ENABLE_CMSISDAP AND HIDAPI_FOUND)
+	link_directories(${HIDAPI_LIBRARY_DIRS})
+endif()
+
 add_executable(openFPGALoader
 	${OPENFPGALOADER_SOURCE}
 	${OPENFPGALOADER_HEADERS}
@@ -198,8 +221,8 @@
 if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
 	# winsock provides ntohs
 	target_link_libraries(openFPGALoader ws2_32)
-	
-	target_sources(openFPGALoader PRIVATE src/pathHelper.cpp)	
+
+	target_sources(openFPGALoader PRIVATE src/pathHelper.cpp)
 	list(APPEND OPENFPGALOADER_HEADERS src/pathHelper.hpp)
 endif()
 
@@ -214,13 +237,17 @@
 endif()
 
 if (ENABLE_LIBGPIOD)
-	link_directories(${LIBGPIOD_LIBRARY_DIRS})
 	include_directories(${LIBGPIOD_INCLUDE_DIRS})
 	target_link_libraries(openFPGALoader ${LIBGPIOD_LIBRARIES})
 	add_definitions(-DENABLE_LIBGPIOD=1)
 	target_sources(openFPGALoader PRIVATE src/libgpiodJtagBitbang.cpp)
 	list (APPEND OPENFPGALOADER_HEADERS src/libgpiodJtagBitbang.hpp)
-	message("libgpiod support enabled")
+	if (LIBGPIOD_VERSION VERSION_GREATER_EQUAL 2)
+		message("libgpiod v2 support enabled")
+		add_definitions(-DGPIOD_APIV2)
+	else()
+		message("libgpiod v1 support enabled")
+	endif()
 endif(ENABLE_LIBGPIOD)
 
 if (ENABLE_JETSONNANOGPIO)
@@ -254,11 +281,20 @@
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 	add_definitions(-DENABLE_XVC=1)
 	target_sources(openFPGALoader PRIVATE src/xvc_client.cpp src/xvc_server.cpp)
-	list (APPEND OPENFPGALOADER_HEADERS src/xvc_client.hpp src/xvc_server.cpp)
+	list (APPEND OPENFPGALOADER_HEADERS src/xvc_client.hpp src/xvc_server.hpp)
 	set(CMAKE_EXE_LINKER_FLAGS "-pthread ${CMAKE_EXE_LINKER_FLAGS}")
 	message("Xilinx Virtual Server support enabled")
 else()
 		message("Xilinx Virtual Server support disabled")
+endif()
+
+if (ENABLE_REMOTEBITBANG)
+	add_definitions(-DENABLE_REMOTEBITBANG=1)
+	target_sources(openFPGALoader PRIVATE src/remoteBitbang_client.cpp)
+	list (APPEND OPENFPGALOADER_HEADERS src/remoteBitbang_client.hpp)
+	message("Remote bitbang client support enabled")
+else()
+	message("Remote bitbang client support disabled")
 endif()
 
 if (ZLIB_FOUND)
@@ -292,7 +328,7 @@
 list(INSERT CMAKE_MODULE_PATH 0 ${PROJECT_SOURCE_DIR}/cmake/Modules)
 include(FindGZIP)
 
-if (${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND GZIP_PRG)
+if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows" AND GZIP_PRG)
 	set(SPIOVERJTAG_DIR "${CMAKE_CURRENT_SOURCE_DIR}/spiOverJtag")
 	file(GLOB BITS_FILES RELATIVE ${SPIOVERJTAG_DIR} spiOverJtag/spiOverJtag_*.bit)
 	file(GLOB RBF_FILES RELATIVE ${SPIOVERJTAG_DIR} spiOverJtag/spiOverJtag_*.rbf)
@@ -320,7 +356,7 @@
 	)
 endif()
 
-install(FILES 
+install(FILES
 	${GZ_FILES}
 	DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/openFPGALoader
 )

=== doc/Makefile ===
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees -T -D language=en $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

%:
	$(SPHINXBUILD) -b $@ $(ALLSPHINXOPTS) $(BUILDDIR)/$@

=== doc/requirements.txt ===
pyyaml
sphinx
tabulate

=== spiOverJtag/Makefile ===
--- 
+++ 
@@ -1,17 +1,27 @@
-XILINX_PARTS := xc3s500evq100 xc6slx9tqg144 xc6slx16ftg256 xc6slx16csg324 xc6slx45csg324 xc6slx100fgg484 \
-	xc6slx150tfgg484 \
-	xc7a35tcpg236 xc7a35tcsg324 xc7a35tftg256 \
-	xc7a50tcsg324 xc7a50tcpg236 xc7a75tfgg484 \
+XILINX_PARTS := xc3s500evq100 \
+	xc6slx9tqg144 xc6slx9csg324 \
+	xc6slx16ftg256 xc6slx16csg324 xc6slx45csg324 xc6slx100fgg484 \
+	xc6slx150tfgg484 xc6slx150tcsg484 \
+	xc6vlx130tff784 \
+	xc7a15tcpg236 \
+	xc7a25tcpg238 xc7a25tcsg325 \
+	xc7a35tcpg236 xc7a35tcsg324 xc7a35tftg256 xc7a35tfgg484 \
+	xc7a50tcsg324 xc7a50tfgg484 xc7a50tcpg236 xc7a75tfgg484 \
 	xc7a100tcsg324 xc7a100tfgg484 xc7a100tfgg676\
-	xc7a200tsbg484 \
+	xc7a200tsbg484 xc7a200tfbg484 \
 	xc7s25csga225 xc7s25csga324 xc7s50csga324 \
+	xc7k70tfbg484 xc7k70tfbg676 \
 	xc7k160tffg676 \
 	xc7k325tffg676 xc7k325tffg900 \
 	xc7k420tffg901 \
-	xcvu9p-flga2104
+	xcku3p-ffva676 \
+	xc7vx330tffg1157 \
+	xcku5p-ffvb676 \
+	xcvu9p-flga2104 xcvu37p-fsvh2892
 XILINX_BIT_FILES := $(addsuffix .bit.gz,$(addprefix spiOverJtag_, $(XILINX_PARTS)))
 
-ALTERA_PARTS := 10cl025256 10cl055484 ep4ce2217 ep4ce1523 ep4ce11523 5ce223 5ce423 5ce523 5ce927
+ALTERA_PARTS := 10cl025256 10cl016484 10cl055484 \
+	ep4ce2217 ep4ce1523 ep4ce11523 5ce223 5ce423 5ce523 5ce927
 ALTERA_BIT_FILES := $(addsuffix .rbf.gz, $(addprefix spiOverJtag_, $(ALTERA_PARTS)))
 
 BIT_FILES := $(ALTERA_BIT_FILES) $(XILINX_BIT_FILES)

=== debian/changelog ===
openfpgaloader (0.12.0-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/copyright: Added missing license information
    ./src/svf_jtag.cpp: * Copyright (C) 2022 phdussud
    Special thanks go to FTPmaster Thorsten for pointing this out.

  [ Steffen Möller ]
  * New upstream version
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Steffen Möller <moeller@debian.org>  Sun, 17 Mar 2024 21:21:08 +0100

## openfpgaloader 0.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.5)
 
 # set the project name
-project(openFPGALoader VERSION "0.12.0" LANGUAGES CXX)
+project(openFPGALoader VERSION "0.12.1" LANGUAGES CXX)
 add_definitions(-DVERSION=\"v${PROJECT_VERSION}\")
 
 option(ENABLE_OPTIM "Enable build with -O3 optimization level" ON)

=== debian/changelog ===
openfpgaloader (0.12.1-1build1) plucky; urgency=medium

  * Rebuild against latest libgpiod

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 08 Nov 2024 06:21:45 -0500

openfpgaloader (0.12.1-1) unstable; urgency=medium

  * Team upload.

  * New upstream version 0.12.1.
  * Replaced obsolete pkg-config build dependency with pkgconf.
  * Added Appstream metainfo XML (Closes: #1071004).
  * Moved udev rules from /lib/ to /usr/lib/ (Closes: #1073764).
  * Updated Standards-Version from 4.6.2 to 4.7.0. No changes needed.
  * Added text format man page installed using txt2man.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 25 Aug 2024 07:58:05 +0200

=== debian/control ===
--- 
+++ 
@@ -13,8 +13,9 @@
  zlib1g-dev,
  libgpiod-dev,
  cmake,
- pkg-config
-Standards-Version: 4.6.2
+ pkgconf,
+ txt2man
+Standards-Version: 4.7.0
 Homepage: https://github.com/trabucayre/openFPGALoader
 Vcs-Browser: https://salsa.debian.org/electronics-team/openfpgaloader
 Vcs-Git: https://salsa.debian.org/electronics-team/openfpgaloader.git

=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,7 @@
 
 %:
 	dh $@
+
+execute_after_dh_install:
+	mkdir -p $(CURDIR)/debian/openfpgaloader/usr/share/man/man1
+	txt2man -t openFPGALoader -s 1 openFPGALoader.txt > $(CURDIR)/debian/openfpgaloader/usr/share/man/man1/openFPGALoader.1

## openfpgaloader 0.13.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.5)
 
 # set the project name
-project(openFPGALoader VERSION "0.12.1" LANGUAGES CXX)
+project(openFPGALoader VERSION "0.13.1" LANGUAGES CXX)
 add_definitions(-DVERSION=\"v${PROJECT_VERSION}\")
 
 option(ENABLE_OPTIM "Enable build with -O3 optimization level" ON)
@@ -12,6 +12,7 @@
 	option(ENABLE_UDEV "use udev to search JTAG adapter from /dev/xx" ON)
 endif()
 option(ENABLE_CMSISDAP "enable cmsis DAP interface (requires hidapi)" ON)
+option(ENABLE_GOWIN_GWU2X "enable Gowin GWU2X interface" ON)
 if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 	option(ENABLE_LIBGPIOD "enable libgpiod bitbang driver (requires libgpiod)" ON)
 	option(ENABLE_REMOTEBITBANG "enable remote bitbang driver" ON)
@@ -48,10 +49,10 @@
 	find_package(PkgConfig REQUIRED)
 	pkg_check_modules(LIBFTDI REQUIRED libftdi1)
 	pkg_check_modules(LIBUSB REQUIRED libusb-1.0)
-	pkg_check_modules(HIDAPI hidapi-hidraw)
-	# if hidraw not found try with libusb
+	pkg_check_modules(HIDAPI hidapi-libusb)
+	# if libusb not found try with hidraw
 	if (NOT HIDAPI_FOUND)
-		pkg_check_modules(HIDAPI hidapi-libusb)
+		pkg_check_modules(HIDAPI hidapi-hidraw)
 	endif()
 	if (NOT HIDAPI_FOUND)
 		pkg_check_modules(HIDAPI hidapi)
@@ -218,6 +219,16 @@
 	${LIBFTDI_LIBRARIES}
 )
 
+# Gowin GWU2X JTAG interface
+if(ENABLE_GOWIN_GWU2X)
+	target_sources(openFPGALoader PRIVATE src/gwu2x_jtag.cpp)
+	list (APPEND OPENFPGALOADER_HEADERS src/gwu2x_jtag.hpp)
+	add_definitions(-DENABLE_GOWIN_GWU2X=1)
+	message("Gowin GWU2X support enabled")
+else()
+	message("Gowin GWU2X support disabled")
+endif()
+
 if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
 	# winsock provides ntohs
 	target_link_libraries(openFPGALoader ws2_32)

=== spiOverJtag/Makefile ===
XILINX_PARTS := xc3s500evq100 \
	xc6slx9tqg144 xc6slx9csg324 \
	xc6slx16ftg256 xc6slx16csg324 xc6slx25csg324 xc6slx45csg324 xc6slx100fgg484 \
	xc6slx25tcsg324 xc6slx45tfgg484 xc6slx150tfgg484 xc6slx150tcsg484 \
	xc6vlx130tff784 \
	xc7a15tcpg236 \
	xc7a25tcpg238 xc7a25tcsg325 \
	xc7a35tcpg236 xc7a35tcsg324 xc7a35tftg256 xc7a35tfgg484 \
	xc7a50tcsg324 xc7a50tfgg484 xc7a50tcpg236 xc7a75tfgg484 \
	xc7a100tcsg324 xc7a100tfgg484 xc7a100tfgg676\
	xc7a200tsbg484 xc7a200tfbg484 xc7a200tfbg676\
	xc7s6ftgb196 xc7s25csga225 xc7s25csga324 xc7s50csga324 \
	xc7k70tfbg484 xc7k70tfbg676 \
	xc7k160tffg676 \
	xc7k325tffg676 xc7k325tffg900 \
	xc7k420tffg901 \
	xcku3p-ffva676 \
	xc7vx330tffg1157 \
	xcku040-ffva1156 xcku060-ffva1156 \
	xcku5p-ffvb676 \
	xcvu9p-flga2104 xcvu37p-fsvh2892
XILINX_BIT_FILES := $(addsuffix .bit.gz,$(addprefix spiOverJtag_, $(XILINX_PARTS)))

ALTERA_PARTS := 10cl025256 10cl016484 10cl055484 \
	ep4ce622 ep4ce1017 ep4ce2217 ep4ce1523 ep4ce11523 ep4cgx15027 5ce215 5ce223 5ce423 5ce523 5ce927 5sgsd5
ALTERA_BIT_FILES := $(addsuffix .rbf.gz, $(addprefix spiOverJtag_, $(ALTERA_PARTS)))

EFINIX_PARTS := t8f81 t13f256 ti180j484
EFINIX_BIT_FILES := $(addsuffix .bit.gz, $(addprefix spiOverJtag_efinix_, $(EFINIX_PARTS)))

BIT_FILES := $(ALTERA_BIT_FILES) $(EFINIX_BIT_FILES) $(XILINX_BIT_FILES)

all: $(BIT_FILES)

$(EFINIX_BIT_FILES) : spiOverJtag_efinix_%.bit.gz : tmp_efinix_%/efinix_spiOverJtag.bit
	gzip -9 -c $< > $@
tmp_efinix_%/efinix_spiOverJtag.bit : efinix_spiOverJtag.v
	./efinix_build.py --device $*

$(XILINX_BIT_FILES) : spiOverJtag_%.bit.gz : tmp_%/spiOverJtag.bit
	gzip -9 -c $< > $@
tmp_%/spiOverJtag.bit : xilinx_spiOverJtag.v
	./build.py $*

$(ALTERA_BIT_FILES): spiOverJtag_%.rbf.gz: tmp_%/spiOverJtag.rbf
	gzip -9 -c $< > $@
tmp_%/spiOverJtag.rbf: tmp_%/spiOverJtag.sof
	quartus_cpf --option=bitstream_compression=off -c $< $@

tmp_%/spiOverJtag.sof: altera_spiOverJtag.v
	./build.py $*

clean:
	-rm -rf tmp_* *.jou *.log .Xil

=== debian/changelog ===
openfpgaloader (0.13.1-1) unstable; urgency=medium

  * New upstream version
  * Update d/copyright
  * Autogenerate man page with help2man to eliminate static patch
  * Standards-Version: 4.7.2 (routine-update)

 -- Steffen Moeller <moeller@debian.org>  Sun, 02 Mar 2025 21:31:27 +0100

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,8 @@
  libgpiod-dev,
  cmake,
  pkgconf,
- txt2man
-Standards-Version: 4.7.0
+ help2man
+Standards-Version: 4.7.2
 Homepage: https://github.com/trabucayre/openFPGALoader
 Vcs-Browser: https://salsa.debian.org/electronics-team/openfpgaloader
 Vcs-Git: https://salsa.debian.org/electronics-team/openfpgaloader.git

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

execute_before_dh_install:
	help2man -v "-V" $$(find . -name openFPGALoader -type f | grep -v debian | head -n 1) > debian/openFPGALoader.1

clean:
	dh clean
	rm -f debian/openFPGAloader.1

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%openfpgaloader-$1.tar.gz%" \
   https://github.com/trabucayre/openFPGALoader/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
